package de.oaa.xxx.games.common.aufgaben;

import java.util.List;
import java.util.UUID;

import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class Aufgabe {

    private UUID aufgabeId;
    private String kurzText;
    private String text;
    private Integer level;
    private Integer sekundenVon;
    private Integer sekundenBis;
    private UUID gruppeId;
    private List<Werkzeug> benoetigtAktiv;
    private List<Werkzeug> benoetigtPassiv;
    private List<Toy> benoetigteToys;

    @Override
    public String toString() {
        return "Aufgabe[id=" + aufgabeId + ", kurzText=" + kurzText + ", level=" + level
                + ", sekunden=" + sekundenVon + "-" + sekundenBis + ", gruppeId=" + gruppeId + "]";
    }

    public boolean isAufgabePassend(int level, CommonMitspieler aktiv, CommonMitspieler passiv) {
        if (level != this.level && level - 1 != this.level) {
            return false;
        }
        if (benoetigtPassiv != null) {
            for (Werkzeug werkzeug : benoetigtPassiv) {
                if (!passiv.isVerfuegbar(werkzeug)) {
                    return false;
                }
            }
        }
        if (benoetigtAktiv == null || benoetigtAktiv.isEmpty()) {
            return true;
        } else {
            for (Werkzeug werkzeug : benoetigtAktiv) {
                if (aktiv.isVerfuegbar(werkzeug)) {
                    return true;
                }
            }
            return false;
        }
    }
}
